[changes]
* ZxingBarCodes JavaBean now supports "Format" property to create for example Barcode EAN-128 (GS1-128).
* DateDiff formula function now supports TIME value.
* Editable RTF export: Background color for text elements supported. Lines and boxes are not supported in this format.
* For compatibility level <= 8, the default of summary fields is now zero instead of null. This was the original default in these versions.

### HTML Report Viewer
* Saves the zoom level so that it can be set again after a reload.

### i-net Designer
* Stored Procedure is not executed before the parameter request dialog appear. This improves the performance of adding large stored procedures to the report.
* Problem Finder rule that checks for an empty detail section modified. Multi-section-elements are now considered.
* Structure of the i-net Clear Reports properties adapted to the structure of the remote configuration manager.

### Configuration Manager
* Keyboard usage for tables and lists in the configuration manager has been improved.
* Increasing the security, stronger one-way encyption for the Master Password added.

### Plugins
* Changed Remote Printing API plugin to support a global printing job list. Reworked UI for a better user experience.

### Scheduler
* Link "Configure Scheduler now" has been removed from the scheduler GUI. 

[changes:de]
* ZxingBarCodes JavaBean unterstützt jetzt die Eigenschaft "Format", um z.B. Barcode EAN-128 (GS1-128) zu erstellen.
* Die DateDiff-Formelfunktion unterstützt jetzt den TIME-Wert.
* Editierbarer RTF-Export: Hintergrundfarbe für Textelemente wird unterstützt. Linien und Boxen werden in diesem Format nicht unterstützt.
* Für die Kompatibilitätsstufe <= 8 ist der Standardwert für Statistikfelder jetzt Null statt Null. Dies war die ursprüngliche Voreinstellung in diesen Versionen.

### HTML-Berichtsbetrachter
* Speichert die Zoomstufe, so dass sie nach einem Neuladen wieder eingestellt werden kann.

### i-net Designer
* Stored Procedure wird nicht ausgeführt, bevor der Dialog zur Parameterabfrage erscheint. Dies verbessert die Performance beim Hinzufügen großer Stored Procedures zum Report.
* Problem Finder Regel, die auf einen leeren Detailabschnitt prüft, wurde geändert. Multi-Abschnitts-Elemente werden nun berücksichtigt.
* Struktur der i-net Clear Reports Eigenschaften an die Struktur des Remote Configuration Manager angepasst.

### Konfigurations-Manager
* Die Tastaturbedienung für Tabellen und Listen im Konfigurationsmanager wurde verbessert.
* Erhöhung der Sicherheit, stärkere Einwegverschlüsselung für das Master-Passwort hinzugefügt.

### Plugins
* Geändertes Remote Printing API Plugin zur Unterstützung einer globalen Druckauftragsliste. Überarbeitete Benutzeroberfläche für eine bessere Benutzerfreundlichkeit.

### Zeitplaner
* Der Link "Configure Scheduler now" wurde aus der GUI des Schedulers entfernt.

[bugfixes]
* Image export: IllegalStateException occurred if printing was disabled for the exported report.
* Date ranges were not always correctly localized.
* Unicode characters like Polish characters were not encoded in ZxingBarCodes JavaBean. It encoded only iso_1 characters.
* ClassNotFoundException occurred if the configuration contains a custom PropertyChecker.
* XLSX and ODS export: NullPointerException occurred if the classpath contains the Woodstox Stax XML API.
* Error "javax.xml.parsers.FactoryConfigurationError: Provider __redirected.__DocumentBuilderFactory not found" occurred if WildFly was used.
* The "round" formula function has not always used ROUND_HALF_UP like documented.
* In very rare cases the multiplication of large numbers or numbers with a large scale returns a wrong result.
* Regressions: 
  * The cursor of Oracle functions was not registered.
  * Duplicate Oracle procedures in the root and in a package of a schema were not found.
* Data export: Suppressed fields were not refreshed.
* ArrayStoreException occurred if a FormulaExpanderClass with a Binary parameters for functions was used.
* In very rare cases the line chart has overwritten the border of the chart.
* The following Ora4SQLException occurred if a stored procedure with Date type input parameter was added to a report: [OraDriver?] #14 Unknown or unsupported SQL type. <0>.
* SocketException: Invalid argument occurred if only ipv4 is available (-Djava.net.preferIPv4Stack=true).
* Special Field and formula function "ReportFile" has returned absolute report file URL. In case of http URL it returns the relative URL again.
* IllegalStateException: PRE_INIT occurred if a JSP page is the first request after a restart of the report server.
* Login box was displayed multiple times for the first user in application server if the login of the application server was used and the user has login in another program part first.
* NullPointerException occurred if JsonData used as datasource.
* CheckProperties methods in Sample.jsp are not called correctly.
* JSON datasource: Quotes ignored. Therefore strings where interpreted as number.
* Because of some bugs in the JSON-RPC implementation, it was not possible to use the library JSON-RPC 2.0.
* OrderBy part of the SQL statement contains the result of a formula if the report was grouped by a formula.
* "Can grow" text elements with field parts could end up incorrectly duplicating their data in a row if the data had caused a page break on the previous row of data.
* Sometimes NullPointerException could occur after the 10 minutes timeout of the web API has occurred.
* Add also pieces of WHERE from the Record Selection Formula if in addition to the joined tables there is an SQL Command.
* NullPointerException occurred if only JSP or Cache API was used and the report name was not set with complete path.
* NegativeArraySizeException occurred while parsing an BMP image. BMP images with top down line order now supported.
* Prevent a double login box for the first user in the application server if you use the login of the application server and the user has already logged in in another program part.
* The following exception occurred if a certificate with IBM JavaVM was used: java.security.NoSuchAlgorithmException: SunX509 KeyManagerFactory not available.
* XLSX export: Skip zero characters in XLSX output because this produce corrupt XLSX files.
* NullPointerException occurred in case of nested user function calls in formulas.
* Postscript export: Memory leak occurred with embedded font Arial Narrow.
* XLS export: "Suppress if Duplicated" does not suppress duplicate fields in some cases.
* Regression: Exception "Total Page Count not supported in this context" occurred while TotalPageCount was only used in a formula that was added to the report design.
* Unhandled Exception "java.lang.InternalError" with message "couldn't create component peer" occurred with Java 8u152.

### Java report viewer
* The design margins when printing via PrinterJobProgress API has been changed if the designed margins are smaller than the printable margins of the printer. Earlier this was done only in the print dialog.
* Regression: If a report was rendered longer than 10 minutes then the error message "wrong mimetype text/html" has occurred.
* Regression since version 15.0: The group tree contained a node more than once if there was not enough space for the group on the previous report page.
* Characters in the chart legends or heading were missing if the chart was included in a subreport and an embedded font was used.
* Subreport on Demand and Interactive Sorting does not work correctly with Java report viewer.
* Java report viewer does not show a report if it is running with Java version 7.
* NullPointerException occurred when adding a report view using API to the report viewer.

### HTML Report Viewer
* In the HTML prompt dialog, manually entering a 2-digit year (e.g. 14) interpreted the year as 0014.
* Subreport position was incorrect if the page contains a watermark and therefore "Underlay following section" was enabled for the page header.
* HTML prompt dialog was not displayed in Microsoft Edge browser on Windows 10.
* Lines crossing multiple sections where missing on page 2 and the following pages if the report contains an "Page N of M" element.
* CSV export if requested - was DATA though CSV has been set. 

### i-net Designer
* Parameter fields where requested in a loop in the Database Wizard, if the count of parameters in an SQL command was increased to 2 or more.
* Row Buffer does not allow values greater than 999.
* Refresh of stored procedures in the Database Wizard has not worked if the stored procedures does not accept Null parameters. 

### Ad Hoc Reporting
* IllegalArgumentException occurred if ad hoc reporting was used on a database repository.
* Ad hoc dataview: "Formula Field not found" error occurred if the formula field was used only in the record selection formula of the ad hoc dataview.
* "Cannot read property 'addEventListener'" occurred in ad hoc reporting.

### Scheduler
* Text and attachments in emails sent by scheduler were in wrong order.

[bugfixes:de]
* Bild-Export: IllegalStateException trat auf, wenn das Drucken für den exportierten Bericht deaktiviert war.
* Datumsbereiche wurden nicht immer korrekt lokalisiert.
* Unicode-Zeichen wie polnische Zeichen wurden in ZxingBarCodes JavaBean nicht kodiert. Es wurden nur iso_1-Zeichen kodiert.
* ClassNotFoundException trat auf, wenn die Konfiguration einen benutzerdefinierten PropertyChecker enthält.
* XLSX- und ODS-Export: NullPointerException trat auf, wenn der Klassenpfad die Woodstox Stax XML API enthält.
* Fehler "javax.xml.parsers.FactoryConfigurationError: Provider __redirected.__DocumentBuilderFactory not found" trat auf, wenn WildFly verwendet wurde.
* Die Formelfunktion "round" hat nicht immer wie dokumentiert ROUND_HALF_UP verwendet.
* In sehr seltenen Fällen liefert die Multiplikation von großen Zahlen oder Zahlen mit einer großen Skala ein falsches Ergebnis.
* Regressionen:
  * Der Cursor von Oracle-Funktionen wurde nicht registriert.
  * Doppelte Oracle-Prozeduren in der Wurzel und in einem Paket eines Schemas wurden nicht gefunden.
* Datenexport: Unterdrückte Felder wurden nicht aufgefrischt.
* ArrayStoreException trat auf, wenn eine FormulaExpanderClass mit binären Parametern für Funktionen verwendet wurde.
* In sehr seltenen Fällen hat das Liniendiagramm den Rand des Diagramms überschrieben.
* Die folgende Ora4SQLException trat auf, wenn eine gespeicherte Prozedur mit einem Eingabeparameter vom Typ Datum zu einem Bericht hinzugefügt wurde: [OraDriver?] #14 Unbekannter oder nicht unterstützter SQL-Typ. <0>.
* SocketException: Ungültiges Argument ist aufgetreten, wenn nur ipv4 verfügbar ist (-Djava.net.preferIPv4Stack=true).
* Die spezielle Feld- und Formelfunktion "ReportFile" hat die absolute URL der Berichtsdatei zurückgegeben. Im Falle einer http-URL wird wieder die relative URL zurückgegeben.
* IllegalStateException: PRE_INIT ist aufgetreten, wenn eine JSP-Seite die erste Anforderung nach einem Neustart des Berichtsservers ist.
* Login-Box wurde für den ersten Benutzer im Applikationsserver mehrfach angezeigt, wenn das Login des Applikationsservers verwendet wurde und der Benutzer sich zuerst in einem anderen Programmteil angemeldet hat.
* NullPointerException trat auf, wenn JsonData als Datenquelle verwendet wurde.
* CheckProperties-Methoden in Sample.jsp werden nicht korrekt aufgerufen.
* JSON-Datenquelle: Anführungszeichen ignoriert. Daher wurden Strings als Zahlen interpretiert.
* Aufgrund einiger Fehler in der JSON-RPC-Implementierung war es nicht möglich, die Bibliothek JSON-RPC 2.0 zu verwenden.
* OrderBy-Teil der SQL-Anweisung enthält das Ergebnis einer Formel, wenn der Bericht durch eine Formel gruppiert wurde.
* "Kann wachsen" Textelemente mit Feldteilen konnten fälschlicherweise ihre Daten in einer Zeile duplizieren, wenn die Daten einen Seitenumbruch in der vorherigen Datenzeile verursacht hatten.
* Manchmal konnte eine NullPointerException auftreten, nachdem der 10-Minuten-Timeout der Web-API eingetreten war.
* Fügen Sie auch Teile von WHERE aus der Datensatzauswahlformel hinzu, wenn es zusätzlich zu den verbundenen Tabellen einen SQL-Befehl gibt.
* NullPointerException trat auf, wenn nur JSP oder Cache API verwendet wurde und der Berichtsname nicht mit vollständigem Pfad angegeben wurde.
* NegativeArraySizeException trat beim Parsen eines BMP-Bildes auf. BMP-Bilder mit Zeilenanordnung von oben nach unten werden jetzt unterstützt.
* Verhindern Sie eine doppelte Login-Box für den ersten Benutzer im Anwendungsserver, wenn Sie den Login des Anwendungsservers verwenden und der Benutzer sich bereits in einem anderen Programmteil angemeldet hat.
* Die folgende Ausnahme trat auf, wenn ein Zertifikat mit IBM JavaVM verwendet wurde: java.security.NoSuchAlgorithmException: SunX509 KeyManagerFactory nicht verfügbar.
* XLSX-Export: Überspringen Sie Null-Zeichen in der XLSX-Ausgabe, da dies korrupte XLSX-Dateien erzeugt.
* NullPointerException trat bei verschachtelten Benutzerfunktionsaufrufen in Formeln auf.
* Postscript-Export: Bei der eingebetteten Schriftart Arial Narrow trat ein Speicherleck auf.
* XLS-Export: "Suppress if Duplicated" unterdrückt in einigen Fällen keine doppelten Felder.
* Regression: Die Exception "Total Page Count not supported in this context" trat auf, wenn TotalPageCount nur in einer Formel verwendet wurde, die dem Berichtsentwurf hinzugefügt wurde.
* Unbehandelte Exception "java.lang.InternalError" mit der Meldung "couldn't create component peer" trat bei Java 8u152 auf.

### Java Report Viewer
* Die Entwurfsränder beim Drucken über PrinterJobProgress API wurden geändert, wenn die Entwurfsränder kleiner sind als die druckbaren Ränder des Druckers. Zuvor war dies nur im Druckdialog möglich.
* Regression: Wenn ein Bericht länger als 10 Minuten gerendert wurde, kam die Fehlermeldung "wrong mimetype text/html".
* Regression seit Version 15.0: Der Gruppenbaum enthielt einen Knoten mehr als einmal, wenn auf der vorherigen Berichtsseite nicht genug Platz für die Gruppe war.
* Zeichen in den Diagrammlegenden oder Überschriften fehlten, wenn das Diagramm in einem Unterbericht enthalten war und eine eingebettete Schriftart verwendet wurde.
* Unterbericht bei Bedarf und interaktive Sortierung funktionieren nicht korrekt mit Java Report Viewer.
* Java Report Viewer zeigt einen Bericht nicht an, wenn er mit Java Version 7 ausgeführt wird.
* NullPointerException trat auf, wenn eine Berichtsansicht über API zum Report Viewer hinzugefügt wurde.

### HTML-Berichtsbetrachter
* Im HTML-Eingabedialog wurde bei manueller Eingabe einer zweistelligen Jahreszahl (z. B. 14) das Jahr als 0014 interpretiert.
* Die Position des Unterberichts war nicht korrekt, wenn die Seite ein Wasserzeichen enthielt und deshalb "Unterlegen des folgenden Abschnitts" für den Seitenkopf aktiviert war.
* Der HTML-Eingabeaufforderungsdialog wurde im Microsoft Edge-Browser unter Windows 10 nicht angezeigt.
* Zeilen, die mehrere Abschnitte kreuzen, fehlten auf Seite 2 und den folgenden Seiten, wenn der Bericht ein Element "Seite N von M" enthält.
* CSV-Export, wenn angefordert - war DATA, obwohl CSV eingestellt wurde.

### i-net Designer
* Parameterfelder wurden in einer Schleife im Datenbank-Assistenten angefordert, wenn die Anzahl der Parameter in einem SQL-Befehl auf 2 oder mehr erhöht wurde.
* Row Buffer lässt keine Werte größer als 999 zu.
* Das Aktualisieren von Stored Procedures im Datenbank-Assistenten hat nicht funktioniert, wenn die Stored Procedures keine Null-Parameter akzeptieren.

### Ad Hoc Reporting
* IllegalArgumentException trat auf, wenn Ad-hoc-Reporting für ein Datenbank-Repository verwendet wurde.
* Ad-hoc-Datenansicht: der Fehler "Formula Field not found" trat auf, wenn das Formel-Feld nur in der Datensatzauswahl-Formel der Ad-hoc-Datenansicht verwendet wurde.
* im Ad-hoc-Reporting trat der Fehler "Cannot read property 'addEventListener'" auf.

### Scheduler
* Text und Anhänge in E-Mails, die vom Scheduler gesendet wurden, waren in falscher Reihenfolge.

[security]

[security:de]
